#include <algorithm>
#include <cstdio>
#include <map>
#include <vector>
using namespace std;

#ifndef DG
#define DG 0
#endif
#define LOG(...) (DG ? fprintf(stderr, __VA_ARGS__) : 0)

#define MIN 100000000000LL

map<long long, long long> shape;

long long getval(long long pos) { return prev(shape.upper_bound(pos))->second; }

void addval(long long pos, long long inc) {
  long long old = getval(pos);
  shape[pos] = old + inc;
  if (!shape.count(pos + 1)) {
    shape[pos + 1] = old;
  }

  if (shape[pos] == prev(shape.find(pos))->second) shape.erase(pos);
  if (shape[pos + 1] == prev(shape.find(pos + 1))->second) shape.erase(pos + 1);
}

int main() {
  int T;
  scanf("%d", &T);
  while (T--) {
    int Q;
    scanf("%d", &Q);

    shape.clear();
    shape[-MIN] = 0;

    long long R = 0;

    for (int q = 1; q <= Q; q++) {
      long long pos, inc;
      scanf("%lld%lld", &pos, &inc);

      // left edge
      long long l = getval(pos - 1) != inc
                        ? pos - 1
                        : prev(shape.lower_bound(pos))->first - 1;
      addval(l, inc);

      // right edge
      long long r =
          getval(pos) != -inc ? pos : shape.lower_bound(pos + 1)->first;
      addval(r, -inc);

      if (DG) {
//        for (const auto& p : shape) LOG("(%lld %lld) ", p.first, p.second);
//        LOG("\n");
      }

      LOG("%lld\n", r - l);
      R += 1LL * q * (r - l);
      R %= 1000000009;
    }
    printf("%lld\n", R);
  }
}
